# frozen_string_literal: true

require "rails_helper"

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe "/homes", type: :request do
  # This should return the minimal set of attributes required to create a valid
  # Home. As you add validations to Home, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) do
    skip("Add a hash of attributes valid for your model")
  end

  let(:invalid_attributes) do
    skip("Add a hash of attributes invalid for your model")
  end

  describe "GET /index" do
    it "renders a successful response" do
      Home.create! valid_attributes
      get homes_url
      expect(response).to be_successful
    end
  end

  describe "GET /show" do
    it "renders a successful response" do
      home = Home.create! valid_attributes
      get home_url(home)
      expect(response).to be_successful
    end
  end

  describe "GET /new" do
    it "renders a successful response" do
      get new_home_url
      expect(response).to be_successful
    end
  end

  describe "GET /edit" do
    it "renders a successful response" do
      home = Home.create! valid_attributes
      get edit_home_url(home)
      expect(response).to be_successful
    end
  end

  describe "POST /create" do
    context "with valid parameters" do
      it "creates a new Home" do
        expect do
          post homes_url, params: { home: valid_attributes }
        end.to change(Home, :count).by(1)
      end

      it "redirects to the created home" do
        post homes_url, params: { home: valid_attributes }
        expect(response).to redirect_to(home_url(Home.last))
      end
    end

    context "with invalid parameters" do
      it "does not create a new Home" do
        expect do
          post homes_url, params: { home: invalid_attributes }
        end.not_to change(Home, :count)
      end

      it "renders a successful response (i.e. to display the 'new' template)" do
        post homes_url, params: { home: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe "PATCH /update" do
    context "with valid parameters" do
      let(:new_attributes) do
        skip("Add a hash of attributes valid for your model")
      end

      it "updates the requested home" do
        home = Home.create! valid_attributes
        patch home_url(home), params: { home: new_attributes }
        home.reload
        skip("Add assertions for updated state")
      end

      it "redirects to the home" do
        home = Home.create! valid_attributes
        patch home_url(home), params: { home: new_attributes }
        home.reload
        expect(response).to redirect_to(home_url(home))
      end
    end

    context "with invalid parameters" do
      it "renders a successful response (i.e. to display the 'edit' template)" do
        home = Home.create! valid_attributes
        patch home_url(home), params: { home: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe "DELETE /destroy" do
    it "destroys the requested home" do
      home = Home.create! valid_attributes
      expect do
        delete home_url(home)
      end.to change(Home, :count).by(-1)
    end

    it "redirects to the homes list" do
      home = Home.create! valid_attributes
      delete home_url(home)
      expect(response).to redirect_to(homes_url)
    end
  end
end
